/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { EventProxy } from "./EventProxy";
import { Point_$type, runOn, markType, PointUtil, String_$type, Delegate_$type } from "./type";
import { Rect } from "./Rect";
import { MouseEventArgs } from "./MouseEventArgs";
import { Dictionary$2 } from "./Dictionary$2";
import { List$1 } from "./List$1";
/**
 * @hidden
 */
export class BaseDOMEventProxy extends EventProxy {
    constructor() {
        super(...arguments);
        this.bx = null;
        this.bq = false;
        this.bw = null;
        this.bi = false;
        this.bu = 0;
        this.bv = 0;
        this.bs = 0;
        this.bt = 0;
        this.by = 0;
        this.cw = null;
        this.cv = null;
        this.bh = false;
        this.bz = -1;
        this.bm = false;
        this.bj = false;
        this.bg = false;
    }
    d() {
        let a = new DOMEventProxy(this.bx, this.bw, this.bq);
        a.aa = this.aa;
        a.al = this.al;
        return a;
    }
    static get br() {
        return (BaseDOMEventProxy.bn || BaseDOMEventProxy.bo);
    }
    be(a) {
        return DOMEventProxy.cx(a);
    }
    bl(e_) {
        let pointerEvent_ = e_.originalEvent;
        let a = false;
        if (BaseDOMEventProxy.bo) {
            a = (pointerEvent_.pointerType == 'touch');
        }
        else {
            a = (pointerEvent_.pointerType == pointerEvent_.MSPOINTER_TYPE_TOUCH);
        }
        return a;
    }
    cn(a) {
        if (!this.ac) {
            if (this.bk(a)) {
                if (this.an == null || this.an(a)) {
                    a.preventDefault();
                }
            }
        }
    }
    bk(e_) {
        return (e_.originalEvent.cancelable || e_.originalEvent.cancelable == undefined);
    }
    cj() {
        let source_ = this.bx.getNativeElement();
        BaseDOMEventProxy.cm(source_);
    }
    static cm(source_) {
        if (BaseDOMEventProxy.bo) {
            source_.style.touchAction = 'none';
        }
        else {
            source_.style.msTouchAction = 'none';
        }
        source_.style.msUserSelect = 'none';
        source_.style.webkitTouchCallout = 'none';
        source_.style.webkitUserSelect = 'none';
        source_.style.khtmlUserSelect = 'none';
        source_.style.mozUserSelect = 'none';
        source_.style.userSelect = 'none';
    }
    static cg(source_) {
        if (BaseDOMEventProxy.bo) {
            source_.style.touchAction = 'auto';
        }
        else {
            source_.style.msTouchAction = 'auto';
        }
        source_.style.msUserSelect = 'auto';
        source_.style.webkitTouchCallout = 'none';
        source_.style.webkitUserSelect = 'auto';
        source_.style.khtmlUserSelect = 'auto';
        source_.style.mozUserSelect = 'auto';
        source_.style.userSelect = 'auto';
    }
    ch() {
        let source_ = this.bx.getNativeElement();
        BaseDOMEventProxy.cg(source_);
    }
    ar() {
        super.ar();
        if (!this.ac) {
            this.cj();
        }
        else {
            this.ch();
        }
    }
    b4() {
        let ver_ = -1;
        let matchIE_ = /Trident\/([\d.]+)/;
        if ((matchIE_.exec(navigator.userAgent) != null)) {
            ver_ = (parseFloat(RegExp.$1));
        }
        return ver_;
    }
    b3() {
        let ver_ = -1;
        let matchIE_ = /Edge\/([\d.]+)/;
        if ((matchIE_.exec(navigator.userAgent) != null)) {
            ver_ = (parseFloat(RegExp.$1));
        }
        return ver_;
    }
    static cl(e_) {
        let a = BaseDOMEventProxy.b5 >= 6;
        let oe_ = e_.originalEvent;
        if ((((typeof e_.pageX == 'undefined')) || a) && oe_.clientX != null) {
            let od_;
            if ((e_.target !== undefined)) {
                od_ = e_.target.ownerDocument;
            }
            else {
                od_ = e_.originalEvent.target.ownerDocument;
            }
            let ed_ = od_ ? od_ : document;
            let doc_ = ed_.documentElement;
            let body_ = ed_.body;
            let clientX_ = oe_.clientX;
            let clientY_ = oe_.clientY;
            let scrollLeft_ = doc_ && doc_.scrollLeft || body_ && body_.scrollLeft || 0;
            let scrollTop_ = doc_ && doc_.scrollTop || body_ && body_.scrollTop || 0;
            let clientLeft_ = doc_ && doc_.clientLeft || body_ && body_.clientLeft || 0;
            let clientTop_ = doc_ && doc_.clientTop || body_ && body_.clientTop || 0;
            e_.pageX = clientX_ + (scrollLeft_ - clientLeft_);
            e_.pageY = clientY_ + (scrollTop_ - clientTop_);
        }
        if ((!e_.pageX)) {
            e_.pageX = e_.originalEvent.pageX;
        }
        if ((!e_.pageY)) {
            e_.pageY = e_.originalEvent.pageY;
        }
        if (((typeof e_.button == 'undefined')) && ((typeof oe_.button != 'undefined'))) {
            e_.button = oe_.button;
        }
    }
    static cx(a) {
        let b = BaseDOMEventProxy.b5 >= 6;
        let source_ = a.getNativeElement();
        let d_ = source_.ownerDocument;
        let doc_ = d_ ? d_.documentElement : null;
        let z_ = doc_ ? doc_.msContentZoomFactor : null;
        let body_ = doc_.body;
        if ((z_ && z_ > 1) || b) {
            let rect_ = source_.getBoundingClientRect();
            let x_ = (rect_.left);
            let y_ = (rect_.top);
            let scrollLeft_ = (doc_ && doc_.scrollLeft || body_ && body_.scrollLeft || 0);
            let scrollTop_ = (doc_ && doc_.scrollTop || body_ && body_.scrollTop || 0);
            let clientLeft_ = (doc_ && doc_.clientLeft || body_ && body_.clientLeft || 0);
            let clientTop_ = (doc_ && doc_.clientTop || body_ && body_.clientTop || 0);
            let c = x_ + scrollLeft_ - clientLeft_;
            let d = y_ + scrollTop_ - clientTop_;
            return new Rect(0, c, d, 0, 0);
        }
        else {
            let e = a.getOffset();
            return new Rect(0, e.left, e.top, 0, 0);
        }
    }
    get b1() {
        return this.by;
    }
    set b1(a) {
        this.by = a;
    }
    cq(a) {
        this.ao = a;
        BaseDOMEventProxy.cl(a);
        let b = BaseDOMEventProxy.cx(this.bx);
        this.bu = a.pageX - b.left;
        this.bv = a.pageY - b.top;
        this.bs = this.bu - this.bf.left;
        this.bt = this.bv - this.bf.top;
        this.cw = { $type: Point_$type, x: this.bu, y: this.bv };
        this.cv = { $type: Point_$type, x: this.bs, y: this.bt };
    }
    cr(e_) {
        this.ao = e_;
        BaseDOMEventProxy.cl(e_);
        if (BaseDOMEventProxy.br) {
            let a = e_.pageX;
            let b = e_.pageY;
            let c = BaseDOMEventProxy.cx(this.bx);
            this.bu = a - c.left;
            this.bv = b - c.top;
        }
        else {
            this.by = 0;
            if (!e_.originalEvent.targetTouches || e_.originalEvent.targetTouches.length < 1) {
                return;
            }
            ;
            this.by = (e_.originalEvent.targetTouches.length);
            let d = (e_.originalEvent.targetTouches[0].pageX);
            let e = (e_.originalEvent.targetTouches[0].pageY);
            let f = BaseDOMEventProxy.cx(this.bx);
            this.bu = d - f.left;
            this.bv = e - f.top;
        }
        this.bs = this.bu - this.bf.left;
        this.bt = this.bv - this.bf.top;
        this.cw = { $type: Point_$type, x: this.bu, y: this.bv };
        this.cv = { $type: Point_$type, x: this.bs, y: this.bt };
    }
    cf(e_) {
        this.cp(e_);
        if (this.ab(this.cw, false, true)) {
            let deltaY_ = 0;
            let ev_ = e_;
            deltaY_ = (ev_.originalEvent ? ev_.originalEvent.deltaY : ev_.deltaY);
            let deltaX_ = 0;
            deltaX_ = (ev_.originalEvent ? ev_.originalEvent.deltaX : ev_.deltaX);
            let a = (ev_.originalEvent ? (ev_.originalEvent.deltaMode == 1) : (ev_.deltaMode == 1));
            if (a) {
                deltaY_ = deltaY_ * 40;
                deltaX_ = deltaX_ * 40;
            }
            let b = this.ag(this.cv, deltaY_);
            let c = this.ah(this.cv, deltaX_);
            if (b || c) {
                this.cn(e_);
            }
        }
    }
    cd(e_) {
        this.cp(e_);
        this.cq(e_);
        if (this.ab(this.cw, false, true)) {
            let ev_ = e_;
            let delta_ = 0;
            if (ev_.wheelDelta) {
                delta_ = ev_.wheelDelta / 120;
            }
            ;
            if (ev_.originalEvent && ev_.originalEvent.wheelDelta) {
                delta_ = ev_.originalEvent.wheelDelta / 120;
            }
            ;
            if (ev_.detail) {
                delta_ = -ev_.detail / 3;
            }
            ;
            if (ev_.originalEvent && ev_.originalEvent.detail) {
                delta_ = -ev_.originalEvent.detail / 3;
            }
            ;
            delta_ = delta_ / 10;
            let a = this.ag(this.cv, delta_);
            if (a) {
                this.cn(e_);
            }
        }
    }
    ck() {
        if (this.bh) {
            if (this.bz == -1) {
                this.bz = this.bw.setTimeout(runOn(this, this.ci), 500);
            }
            else {
                window.clearTimeout(this.bz);
                this.bz = -1;
                this.bz = this.bw.setTimeout(runOn(this, this.ci), 500);
            }
        }
    }
    b6() {
        this.bh = true;
        if (this.bz != -1) {
            window.clearTimeout(this.bz);
            this.bz = -1;
        }
    }
    ci() {
        this.bh = false;
    }
    get bp() {
        return this.bj;
    }
    set bp(a) {
        this.bj = a;
    }
    cb(a) {
        if (this.bj || this.bh) {
            return;
        }
        this.cq(a);
        if (this.bm) {
            this.bm = false;
            this.a3(this.cv);
        }
    }
    cc(a) {
        if (this.bj || this.bh) {
            return;
        }
        this.cq(a);
        this.cp(a);
        let b = new MouseEventArgs();
        b.position = this.cw;
        if (this.ab(this.cw, false, false)) {
            if (!this.bm) {
                this.bm = true;
                this.a2(this.cw);
            }
            this.a4(this.cw, true, false);
            this.at(this.cv, false);
        }
        else if (this.bm) {
            this.cb(a);
        }
    }
    co(a) {
        this.bx.focus();
    }
    ca(a) {
        if (this.bj || this.bh) {
            return;
        }
        this.co(a);
        this.cq(a);
        this.cp(a);
        if (this.ab(this.cw, false, false)) {
            this.bg = true;
            this.a1(this.cw);
            this.au(this.cv, false);
            this.cn(a);
        }
    }
    cs(a) {
        if (this.bj || this.bh) {
            return;
        }
        if (this.bg) {
            this.ce(a);
        }
    }
    ce(a) {
        if (this.bj || this.bh) {
            return;
        }
        this.cp(a);
        if (PointUtil.equals(this.cw, null) || PointUtil.equals(this.cv, null)) {
            this.cq(a);
        }
        let b = this.ab(this.cw, false, false) || this.bg || this.bm;
        this.bg = false;
        this.a5(this.cw);
        this.as(this.cv, false);
        if (b) {
            this.cn(a);
        }
    }
    b7(a) {
        this.b8(a, true);
    }
    b9(a) {
        this.b8(a, false);
    }
    cu(a) {
        return BaseDOMEventProxy.ct(a);
    }
    static ct(a) {
        let b;
        switch (a.which) {
            case 33:
                b = 10;
                break;
            case 34:
                b = 11;
                break;
            case 36:
                b = 13;
                break;
            case 37:
                b = 14;
                break;
            case 38:
                b = 15;
                break;
            case 39:
                b = 16;
                break;
            case 40:
                b = 17;
                break;
            case 9:
                b = 2;
                break;
            case 32:
                b = 9;
                break;
            case 13:
                b = 3;
                break;
            case 27:
                b = 8;
                break;
            case 16:
                b = 4;
                break;
            case 17:
                b = 5;
                break;
            case 18:
                b = 6;
                break;
            case 8:
                b = 1;
                break;
            case 35:
                b = 12;
                break;
            case 45:
                b = 18;
                break;
            case 46:
                b = 19;
                break;
            case 106:
                b = 78;
                break;
            case 107:
                b = 79;
                break;
            case 109:
                b = 80;
                break;
            case 110:
                b = 81;
                break;
            case 111:
                b = 82;
                break;
            case 220:
                b = 85;
                break;
            case 192:
                b = 86;
                break;
            case 191:
                b = 84;
                break;
            case 186:
                b = 83;
                break;
            case 189:
                b = 88;
                break;
            case 187:
                b = 87;
                break;
            default:
                if (112 <= a.which && a.which <= 123) {
                    b = (56 + a.which - 112);
                }
                else if (65 <= a.which && a.which <= 90) {
                    b = (30 + a.which - 65);
                }
                else if (48 <= a.which && a.which <= 57) {
                    b = (20 + a.which - 48);
                }
                else if (96 <= a.which && a.which <= 105) {
                    b = (68 + a.which - 96);
                }
                else {
                    b = 0;
                }
                break;
        }
        return b;
    }
    b8(a, b) {
        let c = this.cu(a);
        let d = c != 0;
        this.cp(a);
        if (d) {
            let e = false;
            if (b) {
                e = this.ae(c);
            }
            else {
                e = this.af(c);
            }
            if (e) {
                this.cn(a);
            }
        }
    }
    cp(a) {
        this.ao = a;
        this.bc = 0;
        if (a.shiftKey) {
            this.bc = this.bc | 4;
        }
        if (a.altKey) {
            this.bc = this.bc | 1;
        }
        if (a.ctrlKey) {
            this.bc = this.bc | 2;
        }
        this.ai = a.button == 2;
    }
    bd() {
        let a = BaseDOMEventProxy.cx(this.bx);
        let b = a.left;
        let c = a.top;
        return { $type: Point_$type, x: b, y: c };
    }
}
BaseDOMEventProxy.$t = markType(BaseDOMEventProxy, 'BaseDOMEventProxy', EventProxy.$);
BaseDOMEventProxy.bn = false;
BaseDOMEventProxy.bo = false;
BaseDOMEventProxy.b5 = 0;
BaseDOMEventProxy.b2 = 0;
/**
 * @hidden
 */
export class DOMEventProxy extends BaseDOMEventProxy {
    constructor(a, b, c) {
        super();
        this.c8 = 0;
        this.c9 = "";
        this.cz = false;
        this.c5 = null;
        this.c1 = new Dictionary$2(String_$type, List$1.$.specialize(Delegate_$type), 0);
        this.dw = null;
        this.c6 = -1;
        this.dx = null;
        this.c3 = 0;
        this.c4 = 0;
        this.c2 = 5;
        this.cy = false;
        this.dv = null;
        this.bq = c;
        this.bw = b;
        this.al = (d) => true;
        this.aa = false;
        DOMEventProxy.c7++;
        this.c8 = DOMEventProxy.c7;
        this.c9 = ".DOMProxy" + this.c8.toString();
        this.bc = 0;
        this.bx = a;
        BaseDOMEventProxy.bn = false;
        try {
            BaseDOMEventProxy.bn = (window.navigator.msPointerEnabled && MSGesture !== undefined);
        }
        catch (d) {
        }
        BaseDOMEventProxy.bo = false;
        try {
            BaseDOMEventProxy.bo = (window.PointerEvent || window.navigator.pointerEnabled);
        }
        catch (e) {
        }
        BaseDOMEventProxy.b5 = this.b4();
        BaseDOMEventProxy.b2 = this.b3();
        this.ap(this.bx, "");
        this.ak = (f) => true;
    }
    da(a, b, c) {
    }
    ap(a, b) {
        let c = a;
        let d = this.c9 + b;
        if (!this.bw.supportsDOMEvents()) {
            return;
        }
        let e = new List$1(Delegate_$type, 0);
        this.c1.addItem(d, e);
        this.da(a, b, e);
        if (!BaseDOMEventProxy.br) {
            e.add(c.listen("mousemove", runOn(this, this.cc)));
            e.add(c.listen("mouseleave", runOn(this, this.cb)));
            e.add(c.listen("mousedown", runOn(this, this.ca)));
            e.add(c.listen("mouseup", runOn(this, this.ce)));
            e.add(this.bw.globalListen("window", "mouseup", runOn(this, this.cs)));
        }
        e.add(c.listen("keydown", runOn(this, this.b7)));
        e.add(c.listen("keyup", runOn(this, this.b9)));
        let source_ = this.bx.getNativeElement();
        if (!this.ac) {
            BaseDOMEventProxy.cm(source_);
        }
        if (BaseDOMEventProxy.br) {
            let f = this.bx.getNativeElement();
            if ((window.MSGesture !== undefined)) {
                let g = (new MSGesture());
                g.target = f;
                this.c5 = g;
                e.add(c.listen("MSGestureStart", runOn(this, this.dd)));
                e.add(c.listen("MSGestureChange", runOn(this, this.db)));
                e.add(c.listen("MSGestureEnd", runOn(this, this.dc)));
            }
            if (BaseDOMEventProxy.bo) {
                e.add(c.listen("pointerdown", runOn(this, this.dg)));
                e.add(c.listen("pointerup", runOn(this, this.dj)));
                e.add(c.listen("pointercancel", runOn(this, this.df)));
                e.add(c.listen("pointermove", runOn(this, this.dh)));
                e.add(c.listen("pointerout", runOn(this, this.di)));
                e.add(c.listen("lostpointercapture", runOn(this, this.de)));
            }
            else {
                e.add(c.listen("MSPointerDown", runOn(this, this.dg)));
                e.add(c.listen("MSPointerUp", runOn(this, this.dj)));
                e.add(c.listen("MSPointerCancel", runOn(this, this.df)));
                e.add(c.listen("MSPointerMove", runOn(this, this.dh)));
                e.add(c.listen("MSPointerOut", runOn(this, this.di)));
                e.add(c.listen("MSLostPointerCapture", runOn(this, this.de)));
            }
        }
        else {
            e.add(c.listen("gesturestart", runOn(this, this.dd)));
            e.add(c.listen("gesturechange", runOn(this, this.db)));
            e.add(c.listen("gestureend", runOn(this, this.dc)));
            e.add(c.listen("touchstart", runOn(this, this.dm)));
            e.add(c.listen("touchmove", runOn(this, this.dl)));
            e.add(c.listen("touchend", runOn(this, this.dk)));
        }
        if (this.bq) {
            e.add(c.listen("wheel", runOn(this, this.cf)));
        }
        else {
            e.add(c.listen("DOMMouseScroll", runOn(this, this.cd)));
            e.add(c.listen("mousewheel", runOn(this, this.cd)));
        }
    }
    dj(e_) {
        let a = this.bl(e_);
        if (a) {
            this.b1 = this.b1 - 1;
            if (this.b1 < 0) {
                this.b1 = 0;
            }
        }
        if (this.b1 < 2 && this.cz && a) {
            this.cz = false;
            let b = (e_.originalEvent.scale);
            this.az(this.cv, b);
        }
        else {
            if (a) {
                this.dk(e_);
            }
            else {
                this.ce(e_);
            }
        }
    }
    de(e_) {
        let a = this.bl(e_);
        if (a) {
            this.b1--;
            if (this.b1 < 0) {
                this.b1 = 0;
            }
        }
        if (this.b1 < 2 && this.cz && a) {
            this.cz = false;
            let b = (e_.originalEvent.scale);
            this.az(this.cv, b);
        }
    }
    df(e_) {
        let a = this.bl(e_);
        if (a) {
            this.b1--;
            if (this.b1 < 0) {
                this.b1 = 0;
            }
        }
        if (this.b1 < 2 && this.cz && a) {
            this.cz = false;
            let b = (e_.originalEvent.scale);
            this.az(this.cv, b);
        }
    }
    dg(e_) {
        let a = this.bl(e_);
        if (this.c5 != null && a) {
            this.b1++;
            this.c5.addPointer((e_.originalEvent.pointerId));
        }
        let eventSource_ = this.bx.getNativeElement();
        if (BaseDOMEventProxy.bo) {
            eventSource_.setPointerCapture(e_.originalEvent.pointerId);
        }
        else {
            eventSource_.msSetPointerCapture(e_.originalEvent.pointerId);
        }
        if (this.b1 > 1 && !this.cz && a) {
            this.cz = true;
            this.cr(e_);
            let b = (e_.originalEvent.scale);
            this.a7(this.cv, b);
        }
        else {
            if (a) {
                this.dm(e_);
            }
            else {
                this.ca(e_);
            }
        }
    }
    dh(e_) {
        let a = this.bl(e_);
        if (this.cz) {
            return;
        }
        if (a) {
            this.dl(e_);
        }
        else {
            this.cc(e_);
        }
    }
    di(e_) {
        let a = this.bl(e_);
        if (this.cz) {
            return;
        }
        if (a) {
        }
        else {
            this.cb(e_);
        }
    }
    dd(e_) {
        this.bm = true;
        this.cp(e_);
        this.cr(e_);
        this.dp();
        if (this.ab(this.cw, true, false)) {
            this.cn(e_);
            if (BaseDOMEventProxy.br && this.b1 < 2) {
                return;
            }
            let a = (e_.originalEvent.scale);
            this.a7(this.cv, a);
        }
    }
    db(e_) {
        this.bm = true;
        this.cp(e_);
        this.cr(e_);
        if (this.ab(this.cw, true, false)) {
            this.cn(e_);
            if (BaseDOMEventProxy.br && this.b1 < 2) {
                return;
            }
            let a = (e_.originalEvent.scale);
            this.a6(this.cv, a);
        }
    }
    dc(e_) {
        this.cn(e_);
        let a = (e_.originalEvent.scale);
        this.bm = false;
        this.cp(e_);
        this.cr(e_);
        if (!BaseDOMEventProxy.br || this.cz) {
            this.az(this.cv, a);
        }
    }
    dm(e_) {
        this.bm = true;
        this.cp(e_);
        this.cr(e_);
        this.dw = this.cv;
        if (this.ab(this.cw, true, false)) {
            if (!this.aa) {
                this.cn(e_);
            }
            else {
                this.bp = true;
            }
            this.a4(this.cw, false, true);
            this.a1(this.cw);
            this.au(this.cv, true);
            this.ds();
        }
    }
    ds() {
        if (this.c6 == -1) {
            this.c3 = this.cw.x;
            this.c4 = this.cw.y;
            this.c6 = this.bw.setTimeout(runOn(this, this.dq), 1500);
        }
    }
    dp() {
        if (Math.abs(this.c3 - this.cw.x) > this.c2 || Math.abs(this.c4 - this.cw.y) > this.c2) {
            this.dt();
        }
    }
    dt() {
        if (this.c6 != -1) {
            window.clearTimeout(this.c6);
            this.c6 = -1;
        }
    }
    dq() {
        this.c6 = -1;
        if (this.bp) {
            this.bp = false;
            this.b6();
        }
        this.a0(this.cv);
    }
    dl(a) {
        this.bm = true;
        this.cp(a);
        this.cr(a);
        if (this.bp) {
            if (this.ab(this.cw, true, false) && this.c0()) {
                this.bp = false;
                this.b6();
            }
        }
        this.dp();
        this.du();
        if (this.ab(this.cw, true, false) && this.b1 == 1 && !this.bp) {
            this.cn(a);
            if (!this.cy) {
                this.cy = true;
                this.dv = this.cv;
                this.ay(this.dv);
            }
            else {
                this.a4(this.cw, true, true);
                this.at(this.cv, true);
                this.ax(this.cv);
            }
        }
    }
    c0() {
        let a = { $type: Point_$type, x: this.dw.x - this.cv.x, y: this.dw.y - this.cv.y };
        if (Math.abs(a.x) < 2 && Math.abs(a.y) < 2) {
            return false;
        }
        if (Math.abs(a.x) > Math.abs(a.y)) {
            a.y = 0;
        }
        if (Math.abs(a.y) > Math.abs(a.x)) {
            a.x = 0;
        }
        return this.al(a);
    }
    dk(a) {
        this.bm = false;
        this.cp(a);
        this.cr(a);
        this.dt();
        if (this.bp) {
            this.bp = false;
            this.b6();
        }
        this.cn(a);
        this.a4(this.cw, false, true);
        this.a5(this.cw);
        if (this.b1 == 0) {
            this.dr(this.cw);
            this.ck();
        }
        if (this.cy && this.b1 == 0) {
            this.cy = false;
            this.dv = null;
            this.aw(this.cv);
            this.ck();
        }
        this.as(this.cv, true);
    }
    dr(a) {
        if (Rect.l_op_Equality(this.dx, null)) {
            this.dx = new Rect(0, a.x - 50, a.y - 50, 100, 100);
            this.bw.setTimeout(runOn(this, this.du), 500);
        }
        else {
            if (a.x >= this.dx.x && a.x <= this.dx.right && a.y >= this.dx.y && a.y <= this.dx.bottom) {
                this.du();
                this.av(a);
            }
        }
    }
    du() {
        this.dx = null;
    }
    dn(a) {
        if (this.c1.containsKey(a)) {
            let b = this.c1.item(a);
            this.c1.removeItem(a);
            for (let c = 0; c < b.count; c++) {
                b._inner[c]();
            }
            b.clear();
        }
    }
    bb(a, b) {
        let c = a;
        let d = this.c9 + b;
        this.dn(d);
    }
    aq() {
        if (this.bx == null) {
            return;
        }
        this.dn(this.c9);
        this.bx = null;
    }
}
DOMEventProxy.$t = markType(DOMEventProxy, 'DOMEventProxy', BaseDOMEventProxy.$);
DOMEventProxy.c7 = 0;
